open Common
type t;;
type trans;;
type state;;
external readTask : string -> string -> t = "vx_readTask";;
external getNrClocks : t -> int = "vx_getNrClocks";;
external getDimension : t -> int = "vx_getDimension";;
external closeTask : t -> unit = "vx_closeTask";;
external getInitialState : t -> state = "vx_getInitialState";;
external getTransitions : t -> state -> trans list = "vx_getTransitions";;
external applyTransition : t -> state -> trans -> state = "vx_applyTransition";;
external stringOfState : t -> state -> string = "vx_stringOfDiscretePart";;
external stringOfTransition : trans -> string = "vx_stringOfTransition";;
(** Given timed automaton and a transition, returns the guard 
with the encoding [i*dim + j]
 *)
external flatGuardOfTransition : t-> trans -> (extended_int * dbm_inequality_type) array = "vx_guardOfTransition";;
external flatInvariantOfDiscreteState : t-> state -> (extended_int * dbm_inequality_type) array = "vx_invariantOfDiscreteState";;
(*
external flatInvariantOfDiscreteState : t-> state -> int * (int array) = "vx_invariantOfDiscreteState";;
 *)
external isTarget : t -> state -> bool = "vx_isTarget";;
external resetOfTransition : t -> trans -> int list = "vx_resetOfTransition";;
external getClockNames : t -> (int * string) list = "vx_getClockNames";;
external getLUBounds : t -> state -> int array -> int array -> unit = "vx_getLUBounds";;
external getInfinity : unit -> int = "vx_getInfinity";;
external getMinusInfinity : unit -> int = "vx_getMinusInfinity";;
external isUrgentOrCommitted : t -> state -> bool = "vx_isUrgentOrCommitted";;
(*external getLUBounds : t -> int * ((int * int) array) = "vx_getLUBounds";;*)
(*external getLUBounds : t -> int array = "vx_getLUBounds";;*)
(*external getLUBounds : t -> (int * int) array = "vx_getLUBounds";;*)
